Index: /trunk/sources/HeuristicLab.Data/3.3/StringDataView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringDataView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringDataView.cs	(revision 2546)
@@ -36,5 +36,5 @@
   /// </summary>
   [Content(typeof(StringData), true)]
-  public partial class StringDataView : ViewBase {
+  public partial class StringDataView : ItemViewBase {
     /// <summary>
     /// Gets or sets the string value to represent visually.
Index: /trunk/sources/HeuristicLab.Logging/3.3/LinechartView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Logging/3.3/LinechartView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Logging/3.3/LinechartView.cs	(revision 2546)
@@ -40,5 +40,5 @@
   /// </summary>
   [Content(typeof(Linechart), true)]
-  public partial class LinechartView : ViewBase {
+  public partial class LinechartView : ItemViewBase {
     private double maxY = double.MinValue, minY = double.MaxValue;
     private static int[] colors = new int[] {
Index: /trunk/sources/HeuristicLab.Logging/3.3/LogView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Logging/3.3/LogView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Logging/3.3/LogView.cs	(revision 2546)
@@ -38,5 +38,5 @@
   /// </summary>
   [Content(typeof(Log), true)]
-  public partial class LogView : ViewBase {
+  public partial class LogView : ItemViewBase {
     /// <summary>
     /// Gets or sets the Log item to represent visually.
Index: /trunk/sources/HeuristicLab.Logging/3.3/PointXYChartView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Logging/3.3/PointXYChartView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Logging/3.3/PointXYChartView.cs	(revision 2546)
@@ -40,5 +40,5 @@
   /// </summary>
   [Content(typeof(PointXYChart), true)]
-  public partial class PointXYChartView : ViewBase {
+  public partial class PointXYChartView : ItemViewBase {
     private static int[] colors = new int[] {
       182,182,255, 
Index: /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs	(revision 2546)
@@ -34,5 +34,5 @@
 namespace HeuristicLab.Operators.Programmable {
   [Content(typeof(ProgrammableOperator), true)]
-  public partial class ProgrammableOperatorView : ViewBase {
+  public partial class ProgrammableOperatorView : ItemViewBase {
     public ProgrammableOperator ProgrammableOperator {
       get { return (ProgrammableOperator)Item; }
Index: /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.cs	(revision 2546)
@@ -36,5 +36,5 @@
   /// </summary>
   [Content(typeof(CombinedOperator), true)]
-  public partial class CombinedOperatorView : ViewBase {
+  public partial class CombinedOperatorView : ItemViewBase {
     /// <summary>
     /// Gets or sets the combined operator to display.
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs	(revision 2546)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs	(revision 2546)
@@ -0,0 +1,123 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.Core.Views;
+
+namespace HeuristicLab.Optimizer {
+  internal static class FileManager {
+
+    private class FileInfo {
+      public string Filename { get; set; }
+      public bool Compressed { get; set; }
+
+      public FileInfo(string filename, bool compressed) {
+        Filename = filename;
+        Compressed = compressed;
+      }
+      public FileInfo(string filename)
+        : this(filename, true) {
+      }
+      public FileInfo()
+        : this(string.Empty, true) {
+      }
+    }
+
+    private static Dictionary<IItem, FileInfo> files = new Dictionary<IItem, FileInfo>();
+    private static NewItemDialog newItemDialog = null;
+    private static OpenFileDialog openFileDialog = null;
+    private static SaveFileDialog saveFileDialog = null;
+
+    public static void New() {
+      if (newItemDialog == null) newItemDialog = new NewItemDialog();
+      if (newItemDialog.ShowDialog() == DialogResult.OK) {
+        MainFormManager.MainForm.ShowView(MainFormManager.CreateDefaultView(newItemDialog.Item));
+        files.Add(newItemDialog.Item, new FileInfo());
+      }
+    }
+
+    public static void Open() {
+      if (openFileDialog == null) {
+        openFileDialog = new OpenFileDialog();
+        openFileDialog.Title = "Open Item";
+        openFileDialog.FileName = "Item";
+        openFileDialog.Multiselect = true;
+        openFileDialog.DefaultExt = "hl";
+        openFileDialog.Filter = "HeuristicLab Files|*.hl|All Files|*.*";
+      }
+
+      if (openFileDialog.ShowDialog() == DialogResult.OK) {
+        foreach (string file in openFileDialog.FileNames) {
+          IItem item = (IItem)XmlParser.Deserialize(file);
+          MainFormManager.MainForm.ShowView(MainFormManager.CreateDefaultView(item));
+          files.Add(item, new FileInfo(file));
+        }
+      }
+    }
+
+    public static void Save() {
+      IItemView activeView = MainFormManager.MainForm.ActiveView as IItemView;
+      if ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Item.GetType()))) {
+        Save(activeView.Item);
+      }
+    }
+    private static void Save(IItem item) {
+      if (files[item].Filename != string.Empty) {
+        if (files[item].Compressed)
+          XmlGenerator.Serialize(item, saveFileDialog.FileName, 9);
+        else
+          XmlGenerator.Serialize(item, saveFileDialog.FileName, 0);
+      } else {
+        SaveAs(item);
+      }
+    }
+
+    public static void SaveAs() {
+      IItemView activeView = MainFormManager.MainForm.ActiveView as IItemView;
+      if ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Item.GetType()))) {
+        SaveAs(activeView.Item);
+      }
+    }
+    public static void SaveAs(IItem item) {
+      if (saveFileDialog == null) {
+        saveFileDialog = new SaveFileDialog();
+        saveFileDialog.Title = "Save Item";
+        saveFileDialog.DefaultExt = "hl";
+        saveFileDialog.Filter = "Uncompressed HeuristicLab Files|*.hl|HeuristicLab Files|*.hl|All Files|*.*";
+        saveFileDialog.FilterIndex = 2;
+      }
+
+      saveFileDialog.FileName = files[item].Filename;
+      if (saveFileDialog.FileName == string.Empty) saveFileDialog.FileName = "Item";
+      if (! files[item].Compressed)
+        saveFileDialog.FilterIndex = 1;
+      else
+        saveFileDialog.FilterIndex = 2;
+
+      if (saveFileDialog.ShowDialog() == DialogResult.OK) {
+        if (saveFileDialog.FilterIndex == 1) {
+          XmlGenerator.Serialize(item, saveFileDialog.FileName, 0);
+        } else {
+          XmlGenerator.Serialize(item, saveFileDialog.FileName, 9);
+        }
+        files[item].Filename = saveFileDialog.FileName;
+        files[item].Compressed = saveFileDialog.FilterIndex != 1;
+      }
+    }
+
+    public static void SaveAll() {
+      var views = from v in MainFormManager.MainForm.Views
+                  where v is IItemView
+                  where CreatableAttribute.IsCreatable(((IItemView)v).Item.GetType())
+                  select v as IItemView;
+
+      foreach (IItemView view in views) {
+        Save(view.Item);
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 2546)
@@ -51,9 +51,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Actions\SaveAsAction.cs" />
-    <Compile Include="Actions\SaveAllAction.cs" />
-    <Compile Include="Actions\SaveAction.cs" />
-    <Compile Include="Actions\OpenAction.cs" />
-    <Compile Include="Actions\NewAction.cs" />
+    <Compile Include="FileManager.cs" />
     <Compile Include="MenuItems\CloseMenuItem.cs" />
     <Compile Include="MenuItems\CloseAllMenuItem.cs" />
@@ -68,11 +64,16 @@
     <Compile Include="MenuItems\NewMenuItem.cs" />
     <Compile Include="MenuItems\Separators.cs" />
-    <Compile Include="NewDialog.cs">
+    <Compile Include="NewItemDialog.cs">
       <SubType>Form</SubType>
     </Compile>
-    <Compile Include="NewDialog.Designer.cs">
-      <DependentUpon>NewDialog.cs</DependentUpon>
+    <Compile Include="NewItemDialog.Designer.cs">
+      <DependentUpon>NewItemDialog.cs</DependentUpon>
     </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Properties\Resources.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>Resources.resx</DependentUpon>
+    </Compile>
     <Compile Include="ToolBarItems\SaveAllToolBarItem.cs" />
     <Compile Include="ToolBarItems\SaveToolBarItem.cs" />
@@ -89,4 +90,12 @@
       <Name>HeuristicLab.Common.Resources-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
+      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
+      <Name>HeuristicLab.Core.Views-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.2\HeuristicLab.MainForm.WindowsForms-3.2.csproj">
       <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
@@ -97,4 +106,8 @@
       <Name>HeuristicLab.MainForm-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
@@ -103,6 +116,10 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="NewDialog.resx">
-      <DependentUpon>NewDialog.cs</DependentUpon>
+    <EmbeddedResource Include="NewItemDialog.resx">
+      <DependentUpon>NewItemDialog.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Properties\Resources.resx">
+      <Generator>ResXFileCodeGenerator</Generator>
+      <LastGenOutput>Resources.Designer.cs</LastGenOutput>
     </EmbeddedResource>
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerApplication.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerApplication.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerApplication.cs	(revision 2546)
@@ -31,5 +31,5 @@
 namespace HeuristicLab.Optimizer {
   [ClassInfo(Name = "Optimizer 3.3", Description="Next generation heuristic optimization environment.")]
-  class HeuristicLabOptimizerApplication : ApplicationBase {
+  internal class HeuristicLabOptimizerApplication : ApplicationBase {
     public override void Run() {
       DockingMainForm mainForm = new DockingMainForm(typeof(IOptimizerUserInterfaceItemProvider));
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs	(revision 2546)
@@ -28,5 +28,8 @@
   [ClassInfo(Name = "HeuristicLab.Optimizer-3.3")]
   [PluginFile(Filename = "HeuristicLab.Optimizer-3.3.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Persistence-3.3")]
   [Dependency(Dependency = "HeuristicLab.Common.Resources-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Core-3.3")]
+  [Dependency(Dependency = "HeuristicLab.Core.Views-3.3")]
   [Dependency(Dependency = "HeuristicLab.MainForm-3.2")]
   [Dependency(Dependency = "HeuristicLab.MainForm.WindowsForms-3.2")]
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/CloseAllMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/CloseAllMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/CloseAllMenuItem.cs	(revision 2546)
@@ -10,15 +10,20 @@
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class CloseAllMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class CloseAllMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "Clos&e All"; }
     }
-
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override int Position {
       get { return 1700; }
+    }
+
+    public override void MainFormInitialized(object sender, EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      ToolStripItem.Enabled = MainFormManager.MainForm.Views.FirstOrDefault() != null;
     }
 
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/CloseMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/CloseMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/CloseMenuItem.cs	(revision 2546)
@@ -10,15 +10,20 @@
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class CloseMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class CloseMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "&Close"; }
     }
-
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override int Position {
       get { return 1600; }
+    }
+
+    public override void MainFormInitialized(object sender, EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      ToolStripItem.Enabled = MainFormManager.MainForm.Views.FirstOrDefault() != null;
     }
 
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/ExitMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/ExitMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/ExitMenuItem.cs	(revision 2546)
@@ -10,17 +10,14 @@
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class ExitMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class ExitMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override string Name {
       get { return "E&xit"; }
     }
-
     public override int Position {
       get { return 1999; }
     }
-
     public override Keys ShortCutKeys {
       get { return Keys.Control | Keys.X; }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/NewMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/NewMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/NewMenuItem.cs	(revision 2546)
@@ -9,25 +9,20 @@
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class NewMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class NewMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "&New..."; }
     }
-
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override int Position {
       get { return 1100; }
     }
-
     public override ToolStripItemDisplayStyle ToolStripItemDisplayStyle {
       get { return ToolStripItemDisplayStyle.ImageAndText; }
     }
-
     public override Image Image {
       get { return Resources.NewIcon; }
     }
-
     public override Keys ShortCutKeys {
       get { return Keys.Control | Keys.N; }
@@ -35,5 +30,5 @@
 
     public override void Execute() {
-      Actions.NewAction.Execute();
+      FileManager.New();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OpenMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OpenMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/OpenMenuItem.cs	(revision 2546)
@@ -9,25 +9,20 @@
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class OpenMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class OpenMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "&Open..."; }
     }
-
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override int Position {
       get { return 1200; }
     }
-
     public override ToolStripItemDisplayStyle ToolStripItemDisplayStyle {
       get { return ToolStripItemDisplayStyle.ImageAndText; }
     }
-
     public override Image Image {
       get { return Resources.OpenIcon; }
     }
-
     public override Keys ShortCutKeys {
       get { return Keys.Control | Keys.O; }
@@ -35,5 +30,5 @@
 
     public override void Execute() {
-      Actions.OpenAction.Execute();
+      FileManager.Open();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs	(revision 2546)
@@ -5,31 +5,35 @@
 using System.Windows.Forms;
 using System.Drawing;
+using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class SaveAllMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class SaveAllMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "Save Al&l"; }
     }
-
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override int Position {
       get { return 1500; }
     }
-
     public override ToolStripItemDisplayStyle ToolStripItemDisplayStyle {
       get { return ToolStripItemDisplayStyle.ImageAndText; }
     }
-
     public override Image Image {
       get { return Resources.SaveAllIcon; }
     }
 
+    public override void MainFormInitialized(object sender, EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      ToolStripItem.Enabled = MainFormManager.MainForm.Views.FirstOrDefault() != null;
+    }
+
     public override void Execute() {
-      Actions.SaveAllAction.Execute();
+      FileManager.SaveAll();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAsMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAsMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAsMenuItem.cs	(revision 2546)
@@ -5,31 +5,38 @@
 using System.Windows.Forms;
 using System.Drawing;
+using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class SaveAsMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class SaveAsMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "Save &As..."; }
     }
-
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override int Position {
       get { return 1400; }
     }
-
     public override ToolStripItemDisplayStyle ToolStripItemDisplayStyle {
       get { return ToolStripItemDisplayStyle.ImageAndText; }
     }
-
     public override Keys ShortCutKeys {
       get { return Keys.Control | Keys.Shift | Keys.S; }
     }
 
+    public override void MainFormInitialized(object sender, EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      IItemView activeView = MainFormManager.MainForm.ActiveView as IItemView;
+      ToolStripItem.Enabled = ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Item.GetType())));
+    }
+
     public override void Execute() {
-      Actions.SaveAsAction.Execute();
+      FileManager.SaveAs();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs	(revision 2546)
@@ -5,35 +5,41 @@
 using System.Windows.Forms;
 using System.Drawing;
+using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class SaveMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class SaveMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "&Save"; }
     }
-
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
     }
-
     public override int Position {
       get { return 1300; }
     }
-
     public override ToolStripItemDisplayStyle ToolStripItemDisplayStyle {
       get { return ToolStripItemDisplayStyle.ImageAndText; }
     }
-
     public override Image Image {
       get { return Resources.SaveIcon; }
     }
-
     public override Keys ShortCutKeys {
       get { return Keys.Control | Keys.S; }
     }
 
+    public override void MainFormInitialized(object sender, EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      IItemView activeView = MainFormManager.MainForm.ActiveView as IItemView;
+      ToolStripItem.Enabled = ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Item.GetType())));
+    }
+
     public override void Execute() {
-      Actions.SaveAction.Execute();
+      FileManager.Save();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/Separators.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/Separators.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/Separators.cs	(revision 2546)
@@ -10,5 +10,5 @@
 
 namespace HeuristicLab.Optimizer.MenuItems {
-  public class SeparatorMenuItem : MenuSeparatorItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class SeparatorMenuItem : MenuSeparatorItemBase, IOptimizerUserInterfaceItemProvider {
     public override IEnumerable<string> Structure {
       get { return new string[] { "&File" }; }
